Use PapiSocketProvider for most PAPI calls
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2019 Cisco and/or its affiliates.
2 # Copyright (c) 2019 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45
46     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
47     case_text="${NODENESS}_${FLAVOR}"
48     case "${case_text}" in
49         "1n_skx" | "1n_tx2")
50             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
51             # script's functions. Env variables are read from ssh output
52             # back to localhost for further processing.
53             hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
54             ssh="ssh root@${hostname} -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # backtics to avoid https://midnight-commander.org/ticket/2142
57             env_vars=`${ssh} "$(declare -f); ${run}"` || {
58                 die "Topology reservation via shim-dcr failed!"
59             }
60             set -a
61             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
62                 die "Source failed!"
63             }
64             set +a
65             ;;
66         "1n_vbox")
67             # We execute reservation on localhost. Sourced script automatially
68             # sets environment variables for further processing.
69             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
70             ;;
71         *)
72             die "Unknown specification: ${case_text}!"
73     esac
74
75     trap 'deactivate_docker_topology' EXIT || {
76          die "Trap attempt failed, please cleanup manually. Aborting!"
77     }
78
79     # Replace all variables in template with those in environment.
80     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
81         die "Topology file create failed!"
82     }
83
84     WORKING_TOPOLOGY="/tmp/topology.yaml"
85     mv topo.yml "${WORKING_TOPOLOGY}" || {
86         die "Topology move failed!"
87     }
88     cat ${WORKING_TOPOLOGY} | grep -v password || {
89         die "Topology read failed!"
90     }
91 }
92
93
94 function activate_virtualenv () {
95
96     # Update virtualenv pip package, delete and create virtualenv directory,
97     # activate the virtualenv, install requirements, set PYTHONPATH.
98
99     # Arguments:
100     # - ${1} - Path to existing directory for creating virtualenv in.
101     #          If missing or empty, ${CSIT_DIR} is used.
102     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
103     # Variables read:
104     # - CSIT_DIR - Path to existing root of local CSIT git repository.
105     # Variables exported:
106     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
107     # Functions called:
108     # - die - Print to stderr and exit.
109
110     set -exuo pipefail
111
112     root_path="${1-$CSIT_DIR}"
113     env_dir="${root_path}/env"
114     req_path=${2-$CSIT_DIR/requirements.txt}
115     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
116     pip install --upgrade virtualenv || {
117         die "Virtualenv package install failed."
118     }
119     virtualenv "${env_dir}" || {
120         die "Virtualenv creation failed."
121     }
122     set +u
123     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
124     set -u
125     pip install --upgrade -r "${req_path}" || {
126         die "Requirements installation failed."
127     }
128     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
129     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
130 }
131
132
133 function archive_tests () {
134
135     # Create .tar.xz of generated/tests for archiving.
136     # To be run after generate_tests, kept separate to offer more flexibility.
137
138     # Directory read:
139     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
140     # File rewriten:
141     # - ${ARCHIVE_DIR}/tests.tar.xz - Archive of generated tests.
142
143     set -exuo pipefail
144
145     tar c "${GENERATED_DIR}/tests" | xz -9e > "${ARCHIVE_DIR}/tests.tar.xz" || {
146         die "Error creating archive of generated tests."
147     }
148 }
149
150
151 function check_download_dir () {
152
153     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
154     #
155     # Variables read:
156     # - DOWNLOAD_DIR - Path to directory pybot takes the build to test from.
157     # Directories read:
158     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
159     # Functions called:
160     # - die - Print to stderr and exit.
161
162     set -exuo pipefail
163
164     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
165         die "No artifacts downloaded!"
166     fi
167 }
168
169
170 function cleanup_topo () {
171
172     # Variables read:
173     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
174     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
175
176     set -exuo pipefail
177
178     python "${PYTHON_SCRIPTS_DIR}/topo_cleanup.py" -t "${WORKING_TOPOLOGY}"
179     # Not using "|| die" as some callers might want to ignore errors,
180     # e.g. in teardowns, such as unreserve.
181 }
182
183
184 function common_dirs () {
185
186     # Set global variables, create some directories (without touching content).
187
188     # Variables set:
189     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
190     # - CSIT_DIR - Path to existing root of local CSIT git repository.
191     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
192     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
193     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
194     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
195     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archive".
196     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
197     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
198     # Directories created if not present:
199     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
200     # Functions called:
201     # - die - Print to stderr and exit.
202
203     set -exuo pipefail
204
205     this_file=$(readlink -e "${BASH_SOURCE[0]}") || {
206         die "Some error during locating of this source file."
207     }
208     BASH_FUNCTION_DIR=$(dirname "${this_file}") || {
209         die "Some error during dirname call."
210     }
211     # Current working directory could be in a different repo, e.g. VPP.
212     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
213     relative_csit_dir=$(git rev-parse --show-toplevel) || {
214         die "Git rev-parse failed."
215     }
216     CSIT_DIR=$(readlink -e "${relative_csit_dir}") || die "Readlink failed."
217     popd || die "Popd failed."
218     TOPOLOGIES_DIR=$(readlink -e "${CSIT_DIR}/topologies/available") || {
219         die "Readlink failed."
220     }
221     RESOURCES_DIR=$(readlink -e "${CSIT_DIR}/resources") || {
222         die "Readlink failed."
223     }
224     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
225         die "Readlink failed."
226     }
227     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
228         die "Readlink failed."
229     }
230
231     ARCHIVE_DIR=$(readlink -f "${CSIT_DIR}/archive") || {
232         die "Readlink failed."
233     }
234     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
235     DOWNLOAD_DIR=$(readlink -f "${CSIT_DIR}/download_dir") || {
236         die "Readlink failed."
237     }
238     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
239     GENERATED_DIR=$(readlink -f "${CSIT_DIR}/generated") || {
240         die "Readlink failed."
241     }
242     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
243 }
244
245
246 function compose_pybot_arguments () {
247
248     # Variables read:
249     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
250     # - DUT - CSIT test/ subdirectory, set while processing tags.
251     # - TAGS - Array variable holding selected tag boolean expressions.
252     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
253     # - TEST_CODE - The test selection string from environment or argument.
254     # Variables set:
255     # - PYBOT_ARGS - String holding part of all arguments for pybot.
256     # - EXPANDED_TAGS - Array of strings pybot arguments compiled from tags.
257
258     set -exuo pipefail
259
260     # No explicit check needed with "set -u".
261     PYBOT_ARGS=("--loglevel" "TRACE")
262     PYBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
263
264     case "${TEST_CODE}" in
265         *"device"*)
266             PYBOT_ARGS+=("--suite" "tests.${DUT}.device")
267             ;;
268         *"func"*)
269             PYBOT_ARGS+=("--suite" "tests.${DUT}.func")
270             ;;
271         *"perf"*)
272             PYBOT_ARGS+=("--suite" "tests.${DUT}.perf")
273             ;;
274         *)
275             die "Unknown specification: ${TEST_CODE}"
276     esac
277
278     EXPANDED_TAGS=()
279     for tag in "${TAGS[@]}"; do
280         if [[ ${tag} == "!"* ]]; then
281             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
282         else
283             EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
284         fi
285     done
286 }
287
288
289 function deactivate_docker_topology () {
290
291     # Deactivate virtual vpp-device topology by removing containers.
292     #
293     # Variables read:
294     # - NODENESS - Node multiplicity of desired testbed.
295     # - FLAVOR - Node flavor string, usually describing the processor.
296
297     set -exuo pipefail
298
299     case_text="${NODENESS}_${FLAVOR}"
300     case "${case_text}" in
301         "1n_skx" | "1n_tx2")
302             hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
303             ssh="ssh root@${hostname} -p 6022"
304             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
305             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
306                 die "Topology cleanup via shim-dcr failed!"
307             }
308             ;;
309         "1n_vbox")
310             enter_mutex || die
311             clean_environment || {
312                 die "Topology cleanup locally failed!"
313             }
314             exit_mutex || die
315             ;;
316         *)
317             die "Unknown specification: ${case_text}!"
318     esac
319 }
320
321
322 function die () {
323
324     # Print the message to standard error end exit with error code specified
325     # by the second argument.
326     #
327     # Hardcoded values:
328     # - The default error message.
329     # Arguments:
330     # - ${1} - The whole error message, be sure to quote. Optional
331     # - ${2} - the code to exit with, default: 1.
332
333     set -x
334     set +eu
335     warn "${1:-Unspecified run-time error occurred!}"
336     exit "${2:-1}"
337 }
338
339
340 function die_on_pybot_error () {
341
342     # Source this fragment if you want to abort on any failed test case.
343     #
344     # Variables read:
345     # - PYBOT_EXIT_STATUS - Set by a pybot running fragment.
346     # Functions called:
347     # - die - Print to stderr and exit.
348
349     set -exuo pipefail
350
351     if [[ "${PYBOT_EXIT_STATUS}" != "0" ]]; then
352         die "Test failures are present!" "${PYBOT_EXIT_STATUS}"
353     fi
354 }
355
356
357 function generate_tests () {
358
359     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
360     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
361     # The generation is done by executing any *.py executable
362     # within any subdirectory after copying.
363
364     # This is a separate function, because this code is called
365     # both by autogen checker and entries calling run_pybot.
366
367     # Directories read:
368     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
369     # Directories replaced:
370     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
371
372     set -exuo pipefail
373
374     rm -rf "${GENERATED_DIR}/tests" || die
375     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
376     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
377     cmd_line+=("-executable" "-name" "*.py")
378     file_list=$("${cmd_line[@]}") || die
379
380     for gen in ${file_list}; do
381         directory="$(dirname "${gen}")" || die
382         filename="$(basename "${gen}")" || die
383         pushd "${directory}" || die
384         ./"${filename}" || die
385         popd || die
386     done
387 }
388
389
390 function get_test_code () {
391
392     # Arguments:
393     # - ${1} - Optional, argument of entry script (or empty as unset).
394     #   Test code value to override job name from environment.
395     # Variables read:
396     # - JOB_NAME - String affecting test selection, default if not argument.
397     # Variables set:
398     # - TEST_CODE - The test selection string from environment or argument.
399     # - NODENESS - Node multiplicity of desired testbed.
400     # - FLAVOR - Node flavor string, usually describing the processor.
401
402     set -exuo pipefail
403
404     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
405     if [[ -z "${TEST_CODE}" ]]; then
406         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
407     fi
408
409     case "${TEST_CODE}" in
410         *"1n-vbox"*)
411             NODENESS="1n"
412             FLAVOR="vbox"
413             ;;
414         *"1n-skx"*)
415             NODENESS="1n"
416             FLAVOR="skx"
417             ;;
418        *"1n-tx2"*)
419             NODENESS="1n"
420             FLAVOR="tx2"
421             ;;
422         *"2n-skx"*)
423             NODENESS="2n"
424             FLAVOR="skx"
425             ;;
426         *"3n-skx"*)
427             NODENESS="3n"
428             FLAVOR="skx"
429             ;;
430         *"2n-dnv"*)
431             NODENESS="2n"
432             FLAVOR="dnv"
433             ;;
434         *"3n-dnv"*)
435             NODENESS="3n"
436             FLAVOR="dnv"
437             ;;
438         *"3n-tsh"*)
439             NODENESS="3n"
440             FLAVOR="tsh"
441             ;;
442         *)
443             # Fallback to 3-node Haswell by default (backward compatibility)
444             NODENESS="3n"
445             FLAVOR="hsw"
446             ;;
447     esac
448 }
449
450
451 function get_test_tag_string () {
452
453     # Variables read:
454     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
455     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
456     # - TEST_CODE - The test selection string from environment or argument.
457     # Variables set:
458     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
459     #   May be empty, not set on event types not adding comment.
460
461     # TODO: ci-management scripts no longer need to perform this.
462
463     set -exuo pipefail
464
465     trigger=""
466     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
467         case "${TEST_CODE}" in
468             *"device"*)
469                 # On parsing error, ${trigger} stays empty.
470                 trigger="$(echo "${GERRIT_EVENT_COMMENT_TEXT}" \
471                     | grep -oE '(devicetest$|devicetest[[:space:]].+$)')" \
472                     || true
473                 # Set test tags as string.
474                 TEST_TAG_STRING="${trigger#$"devicetest"}"
475                 ;;
476             *"perf"*)
477                 # On parsing error, ${trigger} stays empty.
478                 comment="${GERRIT_EVENT_COMMENT_TEXT}"
479                 # As "perftest" can be followed by something, we substitute it.
480                 comment="${comment/perftest-2n/perftest}"
481                 comment="${comment/perftest-3n/perftest}"
482                 comment="${comment/perftest-hsw/perftest}"
483                 comment="${comment/perftest-skx/perftest}"
484                 comment="${comment/perftest-dnv/perftest}"
485                 comment="${comment/perftest-tsh/perftest}"
486                 tag_string="$(echo "${comment}" \
487                     | grep -oE '(perftest$|perftest[[:space:]].+$)' || true)"
488                 # Set test tags as string.
489                 TEST_TAG_STRING="${tag_string#$"perftest"}"
490                 ;;
491             *)
492                 die "Unknown specification: ${TEST_CODE}"
493         esac
494     fi
495 }
496
497
498 function reserve_and_cleanup_testbed () {
499
500     # Reserve physical testbed, perform cleanup, register trap to unreserve.
501     # When cleanup fails, remove from topologies and keep retrying
502     # until all topologies are removed.
503     #
504     # Variables read:
505     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
506     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
507     # - BUILD_TAG - Any string suitable as filename, identifying
508     #   test run executing this function. May be unset.
509     # - BUILD_URL - Any string suitable as URL, identifying
510     #   test run executing this function. May be unset.
511     # Variables set:
512     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
513     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
514     # Functions called:
515     # - die - Print to stderr and exit.
516     # Traps registered:
517     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
518
519     set -exuo pipefail
520
521     while [[ ${TOPOLOGIES[@]} ]]; do
522         for topo in "${TOPOLOGIES[@]}"; do
523             set +e
524             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
525             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
526             opts+=("-u" "${BUILD_URL:-Unknown}")
527             python "${scrpt}" "${opts[@]}"
528             result="$?"
529             set -e
530             if [[ "${result}" == "0" ]]; then
531                 # Trap unreservation before cleanup check,
532                 # so multiple jobs showing failed cleanup improve chances
533                 # of humans to notice and fix.
534                 WORKING_TOPOLOGY="${topo}"
535                 echo "Reserved: ${WORKING_TOPOLOGY}"
536                 trap "untrap_and_unreserve_testbed" EXIT || {
537                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
538                     untrap_and_unreserve_testbed "${message}" || {
539                         die "Teardown should have died, not failed."
540                     }
541                     die "Trap attempt failed, unreserve succeeded. Aborting."
542                 }
543                 # Cleanup check.
544                 set +e
545                 cleanup_topo
546                 result="$?"
547                 set -e
548                 if [[ "${result}" == "0" ]]; then
549                     break
550                 fi
551                 warn "Testbed cleanup failed: ${topo}"
552                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
553                 # WORKING_TOPOLOGY is now empty again.
554                 # Build new topology array.
555                 #   TOPOLOGIES=("${TOPOLOGIES[@]/$topo}")
556                 # does not really work, see:
557                 # https://stackoverflow.com/questions/16860877/remove-an-element-from-a-bash-array
558                 new_topologies=()
559                 for item in "${TOPOLOGIES[@]}"; do
560                     if [[ "${item}" != "${topo}" ]]; then
561                         new_topologies+=("${item}")
562                     fi
563                 done
564                 TOPOLOGIES=("${new_topologies[@]}")
565                 break
566             fi
567         done
568
569         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
570             # Exit the infinite while loop if we made a reservation.
571             break
572         fi
573
574         # Wait ~3minutes before next try.
575         sleep_time="$[ ( $RANDOM % 20 ) + 180 ]s" || {
576             die "Sleep time calculation failed."
577         }
578         echo "Sleeping ${sleep_time}"
579         sleep "${sleep_time}" || die "Sleep failed."
580     done
581     if [[ ${TOPOLOGIES[@]} ]]; then
582         echo "Reservation and cleanup successful."
583     else
584         die "Run out of operational testbeds!"
585     fi
586 }
587
588
589 function run_pybot () {
590
591     # Run pybot with options based on input variables. Create output_info.xml
592     #
593     # Variables read:
594     # - CSIT_DIR - Path to existing root of local CSIT git repository.
595     # - ARCHIVE_DIR - Path to store robot result files in.
596     # - PYBOT_ARGS, EXPANDED_TAGS - See compose_pybot_arguments.sh
597     # - GENERATED_DIR - Tests are assumed to be generated under there.
598     # Variables set:
599     # - PYBOT_EXIT_STATUS - Exit status of most recent pybot invocation.
600     # Functions called:
601     # - die - Print to stderr and exit.
602
603     set -exuo pipefail
604
605     all_options=("--outputdir" "${ARCHIVE_DIR}" "${PYBOT_ARGS[@]}")
606     all_options+=("--noncritical" "EXPECTED_FAILING")
607     all_options+=("${EXPANDED_TAGS[@]}")
608
609     pushd "${CSIT_DIR}" || die "Change directory operation failed."
610     set +e
611     pybot "${all_options[@]}" "${GENERATED_DIR}/tests/"
612     PYBOT_EXIT_STATUS="$?"
613     set -e
614
615     # Generate INFO level output_info.xml for post-processing.
616     all_options=("--loglevel" "INFO")
617     all_options+=("--log" "none")
618     all_options+=("--report" "none")
619     all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
620     all_options+=("${ARCHIVE_DIR}/output.xml")
621     rebot "${all_options[@]}" || true
622     popd || die "Change directory operation failed."
623 }
624
625
626 function select_os () {
627
628     # Populate variables related to local operating system.
629     #
630     # Also install any missing prerequisities CSIT tests need.
631     # TODO: Move the installation to a separate function?
632     #
633     # Variables set:
634     # - VPP_VER_FILE - Name of File in CSIT dir containing vpp stable version.
635     # - IMAGE_VER_FILE - Name of File in CSIT dir containing the image name.
636     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
637
638     set -exuo pipefail
639
640     os_id=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g') || {
641         die "Get OS release failed."
642     }
643
644     case "${os_id}" in
645         "ubuntu"*)
646             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU"
647             VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_BIONIC"
648             PKG_SUFFIX="deb"
649             ;;
650         "centos"*)
651             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_CENTOS"
652             VPP_VER_FILE="VPP_STABLE_VER_CENTOS"
653             PKG_SUFFIX="rpm"
654             ;;
655         *)
656             die "Unable to identify distro or os from ${OS}"
657             ;;
658     esac
659 }
660
661
662 function select_tags () {
663
664     # Variables read:
665     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
666     # - TEST_CODE - String affecting test selection, usually jenkins job name.
667     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
668     #   Can be unset.
669     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
670     # - BASH_FUNCTION_DIR - Directory with input files to process.
671     # Variables set:
672     # - TAGS - Array of processed tag boolean expressions.
673
674     set -exuo pipefail
675
676     # NIC SELECTION
677     start_pattern='^  TG:'
678     end_pattern='^ \? \?[A-Za-z0-9]\+:'
679     # Remove the TG section from topology file
680     sed_command="/${start_pattern}/,/${end_pattern}/d"
681     # All topologies DUT NICs
682     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
683                 | grep -hoP "model: \K.*" | sort -u)
684     # Selected topology DUT NICs
685     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
686                | grep -hoP "model: \K.*" | sort -u)
687     # All topologies DUT NICs - Selected topology DUT NICs
688     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
689         die "Computation of excluded NICs failed."
690     }
691
692     # Select default NIC tag.
693     case "${TEST_CODE}" in
694         *"3n-dnv"* | *"2n-dnv"*)
695             default_nic="nic_intel-x553"
696             ;;
697         *"3n-tsh"*)
698             default_nic="nic_intel-x520-da2"
699             ;;
700         *)
701             default_nic="nic_intel-x710"
702             ;;
703     esac
704
705     # Tag file directory shorthand.
706     tfd="${BASH_FUNCTION_DIR}"
707     case "${TEST_CODE}" in
708         # Select specific performance tests based on jenkins job type variable.
709         *"ndrpdr-weekly"* )
710             readarray -t test_tag_array < "${tfd}/mlr-weekly.txt" || die
711             ;;
712         *"mrr-daily"* )
713             readarray -t test_tag_array < \
714                 "${tfd}/mrr-daily-${FLAVOR}.txt" || die
715             ;;
716         *"mrr-weekly"* )
717             readarray -t test_tag_array < "${tfd}/mrr-weekly.txt" || die
718             ;;
719         * )
720             if [[ -z "${TEST_TAG_STRING-}" ]]; then
721                 # If nothing is specified, we will run pre-selected tests by
722                 # following tags.
723                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDip4base"
724                                 "mrrAND${default_nic}AND1cAND78bANDip6base"
725                                 "mrrAND${default_nic}AND1cAND64bANDl2bdbase"
726                                 "mrrAND${default_nic}AND1cAND64bANDl2xcbase"
727                                 "!dot1q" "!drv_avf")
728             else
729                 # If trigger contains tags, split them into array.
730                 test_tag_array=(${TEST_TAG_STRING//:/ })
731             fi
732             ;;
733     esac
734
735     # Blacklisting certain tags per topology.
736     #
737     # Reasons for blacklisting:
738     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
739     # TODO: Add missing reasons here (if general) or where used (if specific).
740     case "${TEST_CODE}" in
741         *"2n-skx"*)
742             test_tag_array+=("!ipsechw")
743             ;;
744         *"3n-skx"*)
745             test_tag_array+=("!ipsechw")
746             # Not enough nic_intel-xxv710 to support double link tests.
747             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
748             ;;
749         *"2n-dnv"*)
750             test_tag_array+=("!ipsechw")
751             test_tag_array+=("!memif")
752             test_tag_array+=("!srv6_proxy")
753             test_tag_array+=("!vhost")
754             test_tag_array+=("!vts")
755             test_tag_array+=("!drv_avf")
756             ;;
757         *"3n-dnv"*)
758             test_tag_array+=("!memif")
759             test_tag_array+=("!srv6_proxy")
760             test_tag_array+=("!vhost")
761             test_tag_array+=("!vts")
762             test_tag_array+=("!drv_avf")
763             ;;
764         *"3n-tsh"*)
765             test_tag_array+=("!ipsechw")
766             test_tag_array+=("!memif")
767             test_tag_array+=("!srv6_proxy")
768             test_tag_array+=("!vhost")
769             test_tag_array+=("!vts")
770             ;;
771         *"3n-hsw"*)
772             # TODO: Introduce NOIOMMU version of AVF tests.
773             # TODO: Make (both) AVF tests work on Haswell,
774             # or document why (some of) it is not possible.
775             # https://github.com/FDio/vpp/blob/master/src/plugins/avf/README.md
776             test_tag_array+=("!drv_avf")
777             # All cards have access to QAT. But only one card (xl710)
778             # resides in same NUMA as QAT. Other cards must go over QPI
779             # which we do not want to even run.
780             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
781             ;;
782         *)
783             # Default to 3n-hsw due to compatibility.
784             test_tag_array+=("!drv_avf")
785             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
786             ;;
787     esac
788
789     # We will add excluded NICs.
790     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
791
792     TAGS=()
793
794     # We will prefix with perftest to prevent running other tests
795     # (e.g. Functional).
796     prefix="perftestAND"
797     set +x
798     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
799         # Automatic prefixing for VPP jobs to limit the NIC used and
800         # traffic evaluation to MRR.
801         if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
802             prefix="${prefix}mrrAND"
803         else
804             prefix="${prefix}mrrAND${default_nic}AND"
805         fi
806     fi
807     for tag in "${test_tag_array[@]}"; do
808         if [[ "${tag}" == "!"* ]]; then
809             # Exclude tags are not prefixed.
810             TAGS+=("${tag}")
811         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
812             # Empty and comment lines are skipped.
813             # Other lines are normal tags, they are to be prefixed.
814             TAGS+=("${prefix}${tag}")
815         fi
816     done
817     set -x
818 }
819
820
821 function select_topology () {
822
823     # Variables read:
824     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
825     # - FLAVOR - Node flavor string, currently either "hsw" or "skx".
826     # - CSIT_DIR - Path to existing root of local CSIT git repository.
827     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
828     # Variables set:
829     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
830     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
831     # Functions called:
832     # - die - Print to stderr and exit.
833
834     set -exuo pipefail
835
836     case_text="${NODENESS}_${FLAVOR}"
837     case "${case_text}" in
838         # TODO: Move tags to "# Blacklisting certain tags per topology" section.
839         # TODO: Double link availability depends on NIC used.
840         "1n_vbox")
841             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
842             TOPOLOGIES_TAGS="2_node_single_link_topo"
843             ;;
844         "1n_skx" | "1n_tx2")
845             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
846             TOPOLOGIES_TAGS="2_node_single_link_topo"
847             ;;
848         "2n_skx")
849             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
850             TOPOLOGIES_TAGS="2_node_*_link_topo"
851             ;;
852         "3n_skx")
853             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
854             TOPOLOGIES_TAGS="3_node_*_link_topo"
855             ;;
856         "2n_dnv")
857             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_dnv*.yaml )
858             TOPOLOGIES_TAGS="2_node_single_link_topo"
859             ;;
860         "3n_dnv")
861             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
862             TOPOLOGIES_TAGS="3_node_single_link_topo"
863             ;;
864         "3n_hsw")
865             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_hsw*.yaml )
866             TOPOLOGIES_TAGS="3_node_single_link_topo"
867             ;;
868         "3n_tsh")
869             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
870             TOPOLOGIES_TAGS="3_node_*_link_topo"
871             ;;
872         *)
873             # No falling back to 3n_hsw default, that should have been done
874             # by the function which has set NODENESS and FLAVOR.
875             die "Unknown specification: ${case_text}"
876     esac
877
878     if [[ -z "${TOPOLOGIES-}" ]]; then
879         die "No applicable topology found!"
880     fi
881 }
882
883
884 function select_vpp_device_tags () {
885
886     # Variables read:
887     # - TEST_CODE - String affecting test selection, usually jenkins job name.
888     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
889     #   Can be unset.
890     # Variables set:
891     # - TAGS - Array of processed tag boolean expressions.
892
893     set -exuo pipefail
894
895     case "${TEST_CODE}" in
896         # Select specific performance tests based on jenkins job type variable.
897         * )
898             if [[ -z "${TEST_TAG_STRING-}" ]]; then
899                 # If nothing is specified, we will run pre-selected tests by
900                 # following tags. Items of array will be concatenated by OR
901                 # in Robot Framework.
902                 test_tag_array=()
903             else
904                 # If trigger contains tags, split them into array.
905                 test_tag_array=(${TEST_TAG_STRING//:/ })
906             fi
907             ;;
908     esac
909
910     TAGS=()
911
912     # We will prefix with devicetest to prevent running other tests
913     # (e.g. Functional).
914     prefix="devicetestAND"
915     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
916         # Automatic prefixing for VPP jobs to limit testing.
917         prefix="${prefix}"
918     fi
919     for tag in "${test_tag_array[@]}"; do
920         if [[ ${tag} == "!"* ]]; then
921             # Exclude tags are not prefixed.
922             TAGS+=("${tag}")
923         else
924             TAGS+=("${prefix}${tag}")
925         fi
926     done
927 }
928
929 function untrap_and_unreserve_testbed () {
930
931     # Use this as a trap function to ensure testbed does not remain reserved.
932     # Perhaps call directly before script exit, to free testbed for other jobs.
933     # This function is smart enough to avoid multiple unreservations (so safe).
934     # Topo cleanup is executed (call it best practice), ignoring failures.
935     #
936     # Hardcoded values:
937     # - default message to die with if testbed might remain reserved.
938     # Arguments:
939     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
940     # Variables read (by inner function):
941     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
942     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
943     # Variables written:
944     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
945     # Trap unregistered:
946     # - EXIT - Failure to untrap is reported, but ignored otherwise.
947     # Functions called:
948     # - die - Print to stderr and exit.
949
950     set -xo pipefail
951     set +eu  # We do not want to exit early in a "teardown" function.
952     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
953     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
954     if [[ -z "${wt-}" ]]; then
955         set -eu
956         warn "Testbed looks unreserved already. Trap removal failed before?"
957     else
958         cleanup_topo || true
959         python "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
960             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
961         }
962         WORKING_TOPOLOGY=""
963         set -eu
964     fi
965 }
966
967
968 function warn () {
969
970     # Print the message to standard error.
971     #
972     # Arguments:
973     # - ${@} - The text of the message.
974
975     set -exuo pipefail
976
977     echo "$@" >&2
978 }